#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>
#include <QGridLayout>
#include <QMenuBar>
#include <QTreeWidget>
#include <QFileDialog>
#include <QFile>
#include <QXmlSimpleReader>
#include <QTextEdit>
#include <QDockWidget>
#include <QTableView>

QT_BEGIN_NAMESPACE
namespace Ui { class MainWindow; }
QT_END_NAMESPACE

class MainWindow : public QMainWindow
{
    Q_OBJECT

public:
    MainWindow(QWidget *parent = nullptr);
    ~MainWindow();

private slots:
    void open_file();
    void clean_tree();
    void close_window();
    void make_query();
    void open_query();
    void make_active();
    void close_file();
    void slot_custom_menu(const QPoint&);

private:
    Ui::MainWindow *ui;
    QTreeWidget* tree_widget;
    QWidget* main_widget;
    QTextEdit* text_edit;
    QTextEdit* text_edit_dock;
    QDockWidget* dock;
    QGridLayout *main_layout;
    QMenu* menu_custom;
    QFile* current_file;
    QTreeWidgetItem* current_pos;
};
#endif // MAINWINDOW_H