#include <QDebug>
#include <QString>
#include <QTableView>
#include <QMessageBox>
#include "parser.h"

parser::parser(QTreeWidget* tree, const QString& name):
    tree_widget(tree),
    widget_item(nullptr),
    title(name)
{}

bool parser::startElement(const QString&,const QString&,const QString& tag_name,const QXmlAttributes&) {
    if (tag_name == "catalog")
    {
       widget_item = new QTreeWidgetItem(tree_widget);
       widget_item->setText(0, title);
    }
    else if (tag_name == "LINK")
    {
        widget_item = new QTreeWidgetItem(widget_item);
        widget_item->setText(0, tag_name);
    }
    else
        widget_item = new QTreeWidgetItem(widget_item);
    widget_item->setFont(0, QFont("Times New Roman", 14));
    return true;
}

bool parser::characters(const QString& strText)
{
    cur_text = strText;
    return true;
}

bool parser::endElement(const QString&, const QString&, const QString& str)
{
    if (str != "array" && str != "catalog" && str != "LINK")
    {
        if (str == "Address")
                    widget_item->parent()->setText(0, cur_text);
        if (str == "Address" || str == "global_id")
                    widget_item->setHidden(true);
        if(str == "AdmArea")
        {
            widget_item->setText(0, "Административный округ: " + cur_text);
        }
        else if(str == "District")
        {
            widget_item->setText(0, "Район: " + cur_text);
        }
        else if(str == "ID")
        {
            widget_item->setText(0, "Код: " + cur_text);
        }
        else
        {
            widget_item->setHidden(true);
        }
        widget_item = widget_item->parent();
    }
    else if (str == "LINK")
        widget_item = widget_item->parent();
    else if (str == "array")
        widget_item = widget_item->parent();
    return true;
}

bool parser::fatalError(const QXmlParseException& exception)
{
    qDebug() << "Line:" << exception.lineNumber()
             << ", Column:" << exception.columnNumber()
             << ", Message:" << exception.message();
    return false;
}